:root {
  /* Hues of blue: */
  --background1: #394263; /* the darkest */
  --background5: #414b71;
  --background6: #486390;
  --background2: #3F577E;
  --background3: #4E597E;
  --background4: #6C84B2; /* the lightest */

  --accent1: #14A7AF; /* blue green */

  --black: darkgrey;
  --white: #E8E9EB;

  /* For elements above the 3D view, will be inverted if the background is set to black: */
  --stage-black: black;
  --stage-white: white;
}

html, body {
  height:100%;
  width:100%;
  margin:0px;
  padding: 0px;
  overflow: hidden;
}

body {
  font-family: Arial, sans-serif;
}

/**
* 3D stage
*/

#viewport {
  position:fixed;
  bottom:0;
  left:0;
  height: calc(100% - 50px);
  width: calc(100% - 350px);
}

/**
* Icons
*/

.fa_button {  /* font-awesome icons as buttons */
  font-size: 10px;
  margin: none;
  border: none;
  background: none;
  outline: none;
}

.fa_button:hover {
  cursor: pointer;
}

/**
* Menu
*/

#menu {
  position:fixed;
  top:0;
  right:0;
  width:350px;
  height:100%;

  overflow-y: scroll;
  /*Note: With this, browsers always display scrollbars whether or not any content is actually clipped, preventing scrollbars from appearing or disappearing as content changes.*/
  /*Otherwise we'd have to deal with the menu resizing*/

  background-color: var(--background1);
}

#menu * {
  color: var(--white);
}

.structure_title {
  padding: 15px;
  font-size: 20px;
}

.buttons_for_the_whole_structure {
  margin-left: 15px;
  width: fit-content;
  line-height: 30px; /* sets the height so that elements can be vertically aligned */
  border-radius: 5px;
  border: 1px solid var(--background5);
}

.vertical_line_1 {  /* separator for the buttons in the buttons_for_the_whole_structure divs */
  border-left: 1px solid var(--background5);
}

.buttons_for_the_whole_structure > .fa_button {
  padding: 10px;
  padding-left: 25px;
  padding-right: 25px;
  color: var(--white);
}

.player_div {
  margin: 15px;
  margin-left: 10px;
  margin-right: 10px;
  color: var(--white);
  font-size: 10px;
}

.player_div > * {
  vertical-align: middle;
}

.slider {
  width: 145px;
  margin-right: 10px;
}

.selection_div {
  background-color: var(--background2);
  border-radius: 15px;
  padding: 8px;
}

.selection_div_title {
  border-radius: 5px;
  display: flex;
  justify-content: space-between;
  font-size: 15px;
  padding: 10px;
}

.selection_div_title:hover {
  cursor: pointer;
  background-color: var(--background6);
  transition: 0.3s;
}

.selection_block, .add_selection_button {
  margin-left: 12px;
  margin-top: 3px;
  margin-bottom: 3px;
  padding: 5px;
  border-radius: 5px;
  border: 1px solid var(--background6);
}

.add_selection_button { /* it's a div */
  font-size: 12px;
  padding-right: 10px;
  padding-left: 10px;
  width: fit-content;
}

.add_selection_button:hover {
  cursor: pointer;
  border: 1px solid var(--white);
}

.selection_block_buttons_div {
  border-top: 1px solid var(--background6);
  display: flex;
  justify-content: space-evenly;
  line-height: 20px;
}

.selection_block_input_div {
  padding: 5px;
}

.selection_block_buttons_div > button {
  padding: 5px;
  margin-top: 5px;
}

.vertical_line_2 {  /* separator for the buttons in the selection_blocks divs */
  border-left: 1px solid var(--background6);
  margin-top: 5px;
}

.selection_block {
  margin-right: 20px;
}

.residues_input_div * {
  vertical-align: middle;
}

.residues_input {
  width: 200px;
  background-color: var(--background4);
  border: 1px solid var(--accent1);
  padding: 3px;
  margin-right: 3px;
  border-radius: 1px;
}

.residues_input::placeholder {
  color: var(--background2);
}

.validate_selection {
  height: 24px;
  background-color: var(--accent1);
  border: none;
  font-size: 12px;
  font-weight: bold;
}

.fa-question-circle {
  color: var(--background4) !important;
  font-size: 15px;
  padding-right: 0px;
}

.eplets_input_div {
  font-size: 13px;
}

.eplet {
  padding: 0px;
  cursor: pointer;
  border: none;
  margin: 1px;
  display: inline;
}

.info_eplets {
  width:inherit;
}

.info_eplets > * {
  font-size: 8px;
  height: inherit;
  width: calc(50% - 1.5px);
  text-align: center;
}

.name_eplet {
  padding: 1px;
  border: 1px solid var(--background1);
}

.score_eplet, .statut_eplet {
  border-bottom: 1px solid var(--background1);
  border-left: 1px solid var(--background1);
  float: left;
}

.statut_eplet {
  border-right: 1px solid var(--background1);
}

#eplets_list {
  text-align: center;
}

.eplet * {
  background-color: var(--background2);
}

.eplet.active * {   /* for all descendants of an active eplet button */
  background-color: var(--accent1);
}

.eplets_selection {
  border: none;
  outline: none;
  margin: 2px;
  font-size: 12px;
  border-radius: 10px;
  background-color: var(--background4);
}

.eplets_selection.active {
  background-color: var(--background1);
}

.patches_input_div {
  font-size: 13px;
}

.patch_central_residue_input {
  width: 95px;
  background-color: var(--background4);
  border: 1px solid var(--accent1);
  padding: 2px;
  border-radius: 1px;
}

.patch_central_residue_input::placeholder, .patch_radius_input::placeholder {
  color: var(--background2);
}

.patch_radius_input {
  width: 60px;
  background-color: #6C84B2;
  border: 1px solid var(--accent1);
  padding: 2px;
  border-radius: 1px;
}

.patch_radius_unit {
  margin-left:-15px;
  margin-right: 10px; /* for the next element */
}

.style_button {
  border: none;
  background: none;
  color: var(--white);
}

.style_button:hover {
  cursor: pointer;
  border: solid 2px var(--background3);
  border-radius: 2px;
  transition: 0.3s;
}

.style_button.active {
  border: solid 2px var(--white);
  border-radius: 2px;
}

.style_window {
  position:absolute;
  width:auto;
  height:auto;
  background-color: var(--background4);
  padding:5px;
}

.style_window_arrow {
  position:absolute;
  width: 0;
  height: 0;
  border-top: 10px solid transparent;
  border-left: 13px solid var(--background4);
  border-bottom: 10px solid transparent;
}

.patch_details {
  margin-top: 5px;
}

.deleteInfo:after { /*displayed after a delete button is clicked*/
    color: red;
    position: absolute;
    transform: translate(-50%,-250% );
    content: "double-click to delete";
    font-size: 10px;
    display: block;
}

/**
* General parameters, labels, scales
*/

#general_parameters {
  position:fixed;
  bottom:30px;
  right: 360px;
  height:30px;
  width:100px;
  color: var(--stage-black);
}

#general_parameters > * {
  color: var(--stage-black);
}

#general_labels {
  position:fixed;
  bottom:30px;
  left:50px;
  font-size: 13px;
  color: var(--stage-black);
}

#gradients_labels {
  position:fixed;
  bottom:80px;
  left:50px;
  display: flex;
  color: var(--stage-black);
}

.color_scale {
  width: 10px;
  height: 50px;
  margin-top: 2px;
  margin-bottom: 5px;
  float: left;
  border: 1px solid var(--stage-black);
}

.color_scale_labels {
  margin-left: 3px;
  margin-right: 5px;
  font-size: 8px;
  height: 54px;
  float: left;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
}

.color_scale_title {
  font-size: 10px;
  font-weight: bold;
  margin-right: 5px;
}

.info_dialog {
  width: auto;
  max-width: 450px;
  min-width: 200px;
  height: auto;
  padding: 10px;
  position: fixed;
  top: 100px;
  left: 50%;
  transform: translateX(-50%);  /*to properly center the dialog box*/

  background-color: var(--background4);
  color: var(--white);
  font-size: 12px;
}

.info_message_close_button {
  margin-top: 10px;
  float: right;
}

/**
* Sequence panel
*/

#sequence_nav {
  position:fixed;
  top:0;
  left:0;
  width: calc(100% - 350px);
  background-color: var(--background2);

  overflow-x: scroll;
  overflow-y: hidden;
  white-space: nowrap;
  display: inline-flex;
}

#sequence_names {
  display: none;
  flex-direction: column;
  justify-content: flex-end;
}

#sequence_names > div {
  height: 18px;
  font-size: 13px;
  color: var(--white);
  margin-bottom: 1px;
  margin-right: 5px;
}

#positions {
  font-family: monospace;
  font-size: 12px;
  color: var(--white);
}

.positions_div {
  display: inline-block;
  width: 180px;
  padding: 0px;
  margin:0px;
}

.residue {
  border: none;
  font-size: 13px;
  display: inline-block; /* to be able to set the width */
  width: 18px;
  height: 18px;
  text-align: center;
  padding:0px;
  margin:0px;
  outline:none;
  background-color: var(--background2);
  color: var(--white);
}

.missing_residue {
  background-color: var(--background4);
}

.selected_residue {
  background-color: black;
  color:white;
}

.polymorphism {
  color: red !important;
}

/**
* Information / summary panel
*/

#info_panel {
  border: solid 3px var(--stage-black);
  color: var(--stage-black);
  background-color: var(--stage-white);
  border-left:none;
  border-radius: 0px 10px 10px 0px;
  width: 300px;
  height: auto;
  position: fixed;
  top: 100px;
  left: 0;
  padding: 18px;
  font-size: 11pt;
}

#info_panel_button {
  border: solid 3px var(--stage-black);
  border-left: none;
  border-radius: 0px 5px 5px 0px;
  position: fixed;
  top: 110px;
  left: 339px;  /* offsetWidth of panel */
  padding: 5px;
  background-color: var(--stage-white);
  color: var(--stage-black);
}

.structure_color_summary {
  display: inline-block;
}

.info_panel_list_icon {
  padding-right: 5px;
  color: var(--background4);
  font-size: 10px;
}

.info_panel_color_dot {
  margin-left: 5px;
  height: 10px;
  width: 10px;
  border-radius: 50%;
  display: inline-block;
}

.info_panel_color_scheme_name_wrap {
  margin-left: 5px;
  border-radius: 10px;
  padding: 3px;
  display: inline-block;
}

.info_panel_color_scheme_name {
  border-radius: 6px;
  font-size: 10px;
  padding: 2px;
  background-color: var(--stage-white);
}

/**
* Loading screen
*/

.opaque {
    position: fixed;
    top: 0px;
    left: 0px;
    width: 100%;
    height: 100%;
    z-index: 1000;
    background-color: black;
    filter: alpha(opacity=30);
    opacity: 0.3;
    display: flex;
    justify-content: center;
    align-items: center;
}

/* Flashing dots animation taken from: https://codepen.io/nzbin/pen/GGrXbp */
.dot-flashing {
  position: relative;
  width: 10px;
  height: 10px;
  border-radius: 5px;
  background-color: #9880ff;
  color: #9880ff;
  animation: dotFlashing 1s infinite linear alternate;
  animation-delay: .5s;
}

.dot-flashing::before, .dot-flashing::after {
  content: '';
  display: inline-block;
  position: absolute;
  top: 0;
}

.dot-flashing::before {
  left: -15px;
  width: 10px;
  height: 10px;
  border-radius: 5px;
  background-color: #9880ff;
  color: #9880ff;
  animation: dotFlashing 1s infinite alternate;
  animation-delay: 0s;
}

.dot-flashing::after {
  left: 15px;
  width: 10px;
  height: 10px;
  border-radius: 5px;
  background-color: #9880ff;
  color: #9880ff;
  animation: dotFlashing 1s infinite alternate;
  animation-delay: 1s;
}

@keyframes dotFlashing {
  0% {
    background-color: #9880ff;
  }
  50%,
  100% {
    background-color: #ebe6ff;
  }
}
